<!DOCTYPE html>
<html ng-app="app">
<head>
  <title>Todo list</title>
</head>
<body>

<div ng-view></div>

<!-- Libraries -->
<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.2.25/angular.min.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.2.25/angular-route.min.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.2.25/angular-resource.min.js"></script>

<!-- Templates -->

<script type="text/ng-template" id="/todos.html">
  <ul>
    <input type="text" placeholder="Something to do..." ng-model="newTodo">    
    <button ng-click="save()">Add</button>
    <br>
    <br>
    Search: <input type="text" ng-model="search.title">
    <br>
    <br>
    <li ng-repeat="todo in todos | filter: search">
      <input type="checkbox" ng-model="todo.completed" ng-change="update($index)">

      <a ng-show="!isEditing[$index]" href="#/{{$index}}">{{todo.title}}</a>
      <button ng-show="!isEditing[$index]" ng-click="isEditing[$index] = true">edit</button>
      <button ng-show="!isEditing[$index]" ng-click="remove($index)">remove</button>

      <input ng-show="isEditing[$index]" type="text" ng-model="todo.title">
      <button ng-show="isEditing[$index]" ng-click="update($index)">update</button>
      <button ng-show="isEditing[$index]" ng-click="isEditing[$index] = false">cancel</button>
    </li>
  </ul>
</script>

<script type="text/ng-template" id="/todoDetail.html">
  <h1>{{todo.title}}</h1>
  Completed: {{todo.completed}} <br>
  Notes:
  <textarea>{{todo.notes}}</textarea>
  <br>
  <button ng-click="save()">save</button>
  <a href="#/">back</a>
</script>


<!-- ng-code -->
<script>
  angular.module('app', ['ngRoute', 'ngResource'])

    .factory('Todos', ['$resource', function ($resource) {
      return [
        {title: 'glocery',  completed: true, notes: 'write something'},
        {title: 'gym',  completed: false, notes: 'write something'},
        {title: 'school',  completed: false, notes: 'write something'},
        {title: 'sleep',  completed: false, notes: 'write something'}
      ];
    }])

    .controller('TodosController', ['$scope', 'Todos', function ($scope, Todos) {
      $scope.todos = Todos;

      $scope.save = function() {
        $scope.todos.push(
            {
              "title" : $scope.newTodo,
              "completed" : false,
              "notes" : "write something"
            }  
          );
      };

    }])

    .controller('TodoDetailCtrl', ['$scope', '$routeParams', 'Todos', function ($scope, $routeParams, Todos) {
      $scope.todo = Todos[$routeParams.id];
    }])

    .config(['$routeProvider', function ($routeProvider) {
      $routeProvider
        .when('/', {
          templateUrl: '/todos.html',
          controller: 'TodosController'
        })

        .when('/:id', {
          templateUrl: '/todoDetail.html',
          controller: 'TodoDetailCtrl'
        });
    }]);
</script>

</body>
</html>

